import { Address } from './Address';
import { AccountResponse, BaseAccountRestResponse } from '../client';
import { AccountDetails } from '../types/auth';
/**
 * @group Util
 */
export declare class BaseAccount extends Address {
    accountNumber: number;
    sequence: number;
    pubKey: {
        type: string;
        key: string;
    };
    constructor({ address, accountNumber, sequence, pubKey, }: {
        address: string;
        accountNumber: number;
        sequence: number;
        pubKey: {
            type: string;
            key: string;
        };
    });
    static fromRestApi(accountResponse: AccountResponse): BaseAccount;
    static fromRestCosmosApi(accountResponse: BaseAccountRestResponse): BaseAccount;
    incrementSequence(): void;
    toAccountDetails(): AccountDetails;
}
