import { QueryParamsResponse as QueryGovernanceParamsResponse, QueryProposalsResponse, QueryProposalResponse, QueryDepositsResponse, QueryTallyResultResponse, QueryVotesResponse } from '@routerprotocol/chain-api/cosmos/gov/v1beta1/query_pb';
import { GovModuleStateParams, Proposal, GrpcProposal, ProposalDeposit, Vote, TallyResult, GrpcTallyResult, GrpcGovernanceDepositParams, GrpcGovernanceVotingParams, GrpcGovernanceTallyParams } from '../types/custom/gov';
import { Pagination } from '../../../types/index';
export declare class ChainGrpcGovTransformer {
    static moduleParamsResponseToModuleParams(response: QueryGovernanceParamsResponse): GovModuleStateParams;
    static moduleParamsResponseToModuleParamsByType({ depositParams, votingParams, tallyParams, }: {
        depositParams: GrpcGovernanceDepositParams;
        votingParams: GrpcGovernanceVotingParams;
        tallyParams: GrpcGovernanceTallyParams;
    }): GovModuleStateParams;
    static proposalResponseToProposal(response: QueryProposalResponse): Proposal;
    static proposalsResponseToProposals(response: QueryProposalsResponse): {
        proposals: Proposal[];
        pagination: Pagination;
    };
    static depositsResponseToDeposits(response: QueryDepositsResponse): {
        deposits: ProposalDeposit[];
        pagination: Pagination;
    };
    static votesResponseToVotes(response: QueryVotesResponse): {
        votes: Vote[];
        pagination: Pagination;
    };
    static tallyResultResponseToTallyResult(response: QueryTallyResultResponse): TallyResult;
    static grpcTallyResultToTallyResult(result: GrpcTallyResult | undefined): TallyResult;
    static grpcProposalToProposal(proposal: GrpcProposal): Proposal;
}
